var CACHE_NAME = 'convention_schedule_pwa_simple';
var urlsToCache = [
    './',
    './index.html',
    './asset-manifest.json',
    './bootstrap.bundle.min.js',
    './bootstrap-reboot.min.css',
    './bootstrap-grid.min.css',
    './bootstrap.min.js',
    './bootstrap.min.css',
    './jquery.js',
    './main.js',
    './makeup.css',
    './manifest.json',
    './popper.js',
    './sw.js'
];

self.addEventListener('install', event => {
    // Perform install steps
    event.waitUntil(
        caches.open(CACHE_NAME)
            .then(cache => {
                console.log('Opened cache');
                return cache.addAll(urlsToCache);
            })
    );
});

self.addEventListener('fetch', function (evt) {
    if(!evt.request.url.endsWith('./sw.js')){
        console.log('The service worker is serving the asset: '+evt.request.url);
        evt.respondWith(fromNetwork(evt.request, 7000).catch(function () {
            return fromCache(evt.request);
        }));
    }
});

function fromNetwork(request, timeout) {
    return new Promise(function (fulfill, reject) {
        var timeoutId = setTimeout(reject, timeout);
        fetch(request).then(function (response) {
            clearTimeout(timeoutId);
            var responseToCache = response.clone();
            caches.open(CACHE_NAME).then(function (cache) {
                cache.put(request, responseToCache);
            });
            return fulfill(response);
        }, reject);
    });
}

function fromCache(request) {
    return caches.open(CACHE_NAME).then(function (cache) {
        return cache.match(request).then(function (matching) {
            return matching || Promise.reject('no-match');
        });
    });
}
